PRGSTART:
;--------------------------------------------
***********************************************************************
d:	lea	Write,a0	; Data Start
	lea	Into,a1		; Data Destination
	bra.w	DePackIt
***********************************************************************
;-------------------------
ZerLn	=64
EquLn	=64
AddLn	=16
SkipLn	=98
	rsreset
			; Zero bytes
ZerCod:	rs.b	ZerLn	; CX
ZerByt:	rs.b	1	; C	X
ZerWor:	rs.b	1	; C	Xb, X
ZerLon:	rs.b	1	; C	Xbb, Xb, X

			; Equal bytes
EquCod:	rs.b	EquLn	; CX	n
EquByt:	rs.b	1	; C	n	X
EquWor:	rs.b	1	; C	n	Xb, X
EquLon:	rs.b	1	; C	n	Xbb, Xb, X

			; Aritmethric sequences
AddCod:	rs.b	AddLn	; CX	A	n
AddByt:	rs.b	1	; C	A	n	X
AddWor:	rs.b	1	; C	A	n	Xb, X
AddLon:	rs.b	1	; C	A	n	Xbb, Xb, X

			; Nonepacked sequences
SkipCod:rs.b	SkipLn	; CX
SkipByt:rs.b	1	; C	X
SkipWor:rs.b	1	; C	Xb, X
SkipLon:rs.b	1	; C	Xbb, Xb, X
StrCode:rs.b	1	; C
EndCode:rs.b	1	; C
;--------------------------------
DePackIt:
	move.l	(a0),d0
	move.l	4(a0),d1
	move.l	#2^24,d2
	cmp.l	d2,d1
	bhi.w	DePerr
	cmp.l	d2,d0
	bhi.w	DePerr
	moveq	#0,d2
	cmp.l	d2,d1
	beq.w	DePerr
	cmp.l	d2,d0
	beq.w	DePerr
	;cmp.l	d1,d0		; Can the crunched data be longer than
	;bhi.w	DePerr		; the uncrunched data?

	lea	(a0,d0.l),a6	; End of Data
	lea	(a1,d1.l),a5	; End of Decrunched data
	cmp.b	#StrCode,-(a6)
	bne.w	DePerr
DecrLoop:
	moveq	#0,d0	; Fill Len
	moveq	#0,d1	; Equ Byte
	moveq	#0,d2	; Add Byte
	move.b	-(a6),d0

	moveq	#0,d3
	cmp.b	#ZerCod+ZerLn,d0
	bhs.b	DecCn1
	sub.b	#ZerCod-1,d0
	bra.w	FillMem
DecCn1:	moveq	#ZerLn+1,d3
	cmp.b	#ZerByt,d0
	bne.b	DecCn2
DecByt:	move.b	-(a6),d0
	bra.w	FillMem
DecCn2:	cmp.b	#ZerWor,d0
	bne.b	DecCn3
DecWor:	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^8,d3
	bra.b	DecByt
DecCn3:	cmp.w	#ZerLon,d0
	bne.b	DecCn4
DecLon:	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^16,d3
	bra.b	DecWor
DecCn4:
	moveq	#0,d3
	cmp.b	#EquCod+EquLn,d0
	bhs.b	DecCn5
	sub.b	#EquCod-2,d0
DecCodN:move.b	-(a6),d1
	bra.w	FillMem
DecCn5:	moveq	#EquLn+2,d3
	cmp.b	#EquByt,d0
	bne.b	DecCn6
DecBytN:move.b	-(a6),d1
	bra.b	DecByt
DecCn6:	cmp.b	#EquWor,d0
	bne.b	DecCn7
DecWorN:move.b	-(a6),d1
	bra.b	DecWor
DecCn7:	cmp.w	#EquLon,d0
	bne.b	DecCn8
DecLonN:move.b	-(a6),d1
	bra.b	DecLon
DecCn8:
	moveq	#0,d3
	cmp.b	#AddCod+AddLn,d0
	bhs.b	DecCn9
	sub.b	#AddCod-3,d0
	move.b	-(a6),d2
	bra.b	DecCodN
DecCn9:	moveq	#AddLn+3,d3
	cmp.b	#AddByt,d0
	bne.b	DecCnA
	move.b	-(a6),d2
	bra.b	DecBytN
DecCnA:	cmp.b	#AddWor,d0
	bne.b	DecCnB
	move.b	-(a6),d2
	bra.b	DecWorN
DecCnB:	cmp.w	#AddLon,d0
	bne.b	DecCnC
	move.b	-(a6),d2
	bra.b	DecLonN
DecCnC:
	moveq	#0,d3
	cmp.b	#SkipCod+SkipLn,d0
	bhs.b	DecCnD
	sub.b	#SkipCod-1,d0
	bra.b	DecrSkip
DecCnD:	moveq	#SkipLn+1,d3
	cmp.b	#SkipByt,d0
	bne.b	DecCnE
DecBytS:move.b	-(a6),d0
	bra.b	DecrSkip
DecCnE:	cmp.b	#SkipWor,d0
	bne.b	DecCnF
DecWorS:move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^8,d3
	bra.b	DecBytS
DecCnF:	cmp.w	#SkipLon,d0
	bne.b	DecCnG
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#2^16,d3
	bra.b	DecWorS
DecCnG:	cmp.b	#EndCode,d0
	beq.b	EndDecr
DecrSkip:add.l	d3,d0
SkpLoop:move.b	(a6),$dff180
	move.b	-(a6),-(a5)
	subq.l	#1,d0
	bne.b	SkpLoop
	bra.w	DecrLoop
FillMem:add.l	d3,d0
FillLop:move.b	d1,$dff180
	move.b	d1,-(a5)
	sub.b	d2,d1
	subq.l	#1,d0
	bne.b	FillLop
	bra.w	DecrLoop
EndDecr:rts
DePerr:	moveq	#-1,d0
DerrLop:move.w	$dff006,$dff180
	dbf	d0,DerrLop
	rts
;--------------------------
Write:	dcb.b	1024,0	; Packed data
Into:	dcb.b	1024,0	; Depacked raw data
;--------------------------
PRGEND:
