****************************************

s:	lea	Source,a0
	lea	Dest,a1
	movem.l	a0/a1,-(sp)
	bsr	DePackIt
	movem.l	(sp)+,a0/a1
	move.l	4(a0),d0
	move.l	a1,a0
	lea	(a1,d0.l),a1
	rts
	; returns a0 = start, a1 = end


ZerLn	= 64
EquLn	= 64
AddLn	= 16
SkipLn	= 98
	rsreset
			; Zero bytes
ZerCod:	rs.b	ZerLn	; CX
ZerByt:	rs.b	1	; C	X
ZerWor:	rs.b	1	; C	Xb, X
ZerLon:	rs.b	1	; C	Xbb, Xb, X

			; Equal bytes
EquCod:	rs.b	EquLn	; CX	n
EquByt:	rs.b	1	; C	n	X
EquWor:	rs.b	1	; C	n	Xb, X
EquLon:	rs.b	1	; C	n	Xbb, Xb, X

			; Aritmethric sequences
AddCod:	rs.b	AddLn	; CX	A	n
AddByt:	rs.b	1	; C	A	n	X
AddWor:	rs.b	1	; C	A	n	Xb, X
AddLon:	rs.b	1	; C	A	n	Xbb, Xb, X

			; Nonepacked sequences
SkipCod:rs.b	SkipLn	; CX
SkipByt:rs.b	1	; C	X
SkipWor:rs.b	1	; C	Xb, X
SkipLon:rs.b	1	; C	Xbb, Xb, X
StrCode:rs.b	1	; C
EndCode:rs.b	1	; C

; a0 = Source adr
; a1 = Dest adr
DePackIt:
	move.l	(a0),d0
	move.l	4(a0),d1
	move.l	#1<<24,d2
	cmp.l	d2,d1
	bhi	.deperr
	cmp.l	d2,d0
	bhi	.deperr
	moveq	#0,d2
	cmp.l	d2,d1
	beq	.deperr
	cmp.l	d2,d0
	beq	.deperr
	;cmp.l	d1,d0		; Can the crunched data be longer than
	;bhi	.deperr		; the uncrunched data?

	lea	(a0,d0.l),a6	; End of Data
	lea	(a1,d1.l),a5	; End of Decrunched data
	cmp.b	#StrCode,-(a6)
	bne	.deperr

.mainloop
	moveq	#0,d0	; Fill Len
	moveq	#0,d1	; Equ Byte
	moveq	#0,d2	; Add Byte
	move.b	-(a6),d0

	moveq	#0,d3
	cmp.b	#ZerCod+ZerLn,d0
	bhs.s	.decn1
	sub.b	#ZerCod-1,d0
	bra	.fillmem
.decn1	moveq	#ZerLn+1,d3
	cmp.b	#ZerByt,d0
	bne.s	.decn2
.decbyt	move.b	-(a6),d0
	bra	.fillmem
.decn2	cmp.b	#ZerWor,d0
	bne.s	.decn3
.decwor	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<8,d3
	bra.s	.decbyt
.decn3	cmp.w	#ZerLon,d0
	bne.s	.decn4
.declon	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<16,d3
	bra.s	.decwor

.decn4	moveq	#0,d3
	cmp.b	#EquCod+EquLn,d0
	bhs.s	.decn5
	sub.b	#EquCod-2,d0
.decodn	move.b	-(a6),d1
	bra	.fillmem
.decn5	moveq	#EquLn+2,d3
	cmp.b	#EquByt,d0
	bne.s	.decn6
.decbytn
	move.b	-(a6),d1
	bra.s	.decbyt
.decn6	cmp.b	#EquWor,d0
	bne.s	.decn7
.decworn
	move.b	-(a6),d1
	bra.s	.decwor
.decn7	cmp.w	#EquLon,d0
	bne.s	.decn8
.declonn
	move.b	-(a6),d1
	bra.b	.declon

.decn8	moveq	#0,d3
	cmp.b	#AddCod+AddLn,d0
	bhs.s	.decn9
	sub.b	#AddCod-3,d0
	move.b	-(a6),d2
	bra.s	.decodn
.decn9	moveq	#AddLn+3,d3
	cmp.b	#AddByt,d0
	bne.s	.decna
	move.b	-(a6),d2
	bra.s	.decbytn
.decna	cmp.b	#AddWor,d0
	bne.s	.decnb
	move.b	-(a6),d2
	bra.s	.decworn
.decnb	cmp.w	#AddLon,d0
	bne.s	.decnc
	move.b	-(a6),d2
	bra.s	.declonn

.decnc	moveq	#0,d3
	cmp.b	#SkipCod+SkipLn,d0
	bhs.s	.decnd
	sub.b	#SkipCod-1,d0
	bra.s	.decrskip
.decnd	moveq	#SkipLn+1,d3
	cmp.b	#SkipByt,d0
	bne.s	.decne
.decbyts
	move.b	-(a6),d0
	bra.s	.decrskip
.decne	cmp.b	#SkipWor,d0
	bne.s	.decnf
.decwors
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<8,d3
	bra.s	.decbyts
.decnf	cmp.w	#SkipLon,d0
	bne.s	.decng
	move.b	-(a6),d0
	lsl.l	#8,d0
	add.l	#1<<16,d3
	bra.s	.decwors
.decng	cmp.b	#EndCode,d0
	beq.s	.enddecr
.decrskip
	add.l	d3,d0
.skploop
	;move.b	(a6),$dff180
	move.b	-(a6),-(a5)
	subq.l	#1,d0
	bne.s	.skploop
	bra	.mainloop
.fillmem
	add.l	d3,d0
.filllp	;move.b	d1,$dff180
	move.b	d1,-(a5)
	sub.b	d2,d1
	subq.l	#1,d0
	bne.s	.filllp
	bra	.mainloop
.enddecr
	rts
.deperr	moveq	#-1,d0
.derrlop
	move.w	$dff006,$dff180
	dbf	d0,.derrlop
	rts
	cnop	0,4
CompPtr	dc.l	0
CompLen	dc.l	0

;-------------------------
	incdir	PTGFX:PAK/
Source:	incbin	'ptsetup.pak'
	cnop	0,4
Dest:	ds.b	1024*100

	END
